//*********************************************************
//  : main.c
// 汾     : V1.1 02/25/2021 MQ6825
//      : 
// ע     : 
//*********************************************************
#ifndef IO_MEM
#define IO_MEM

#endif

#include "main.h"



/* ----------------------  ------------------------------ */




/* ----------------------  -------------------------------- */
void main()
{
    P4CR_P3 = 1;	// 0 = set p43 been output mode
	P4FC_P3 = 0;	// 0 = set p43 been GPIO type
	while(1)
	{
		
		P4DR_P3 =! P4DR_P3;
		delay_times(0,20);
		NOP;
		NOP;
		NOP;
	}
}




/*---------------------- жϷ ------------------------*/
void __interrupt OnlyReti(void)
{
    NOP;                                // ָ
}

void __interrupt_n OnlyRetn(void)
{
    NOP;                                // ָ
}

void __interrupt_n IntWDT(void)
{
    NOP;                                // ָ
}

void __interrupt_n IntSWI(void)
{
    unsigned char tmp;
    tmp =*(unsigned char*)(0xf000);
    while(tmp != *(unsigned char*)(0xf000))
    {
        tmp =*(unsigned char*)(0xf000);
    }
    SYSCR2 = 0x10;                      // system clock reset
}
/*------------ жϷ ------------------------*/

/*------------MQ6825 ж ------------------------*/
#pragma section const INT_VECTOR1
void * const IntTbl1[] = {
    OnlyReti,           // 0xffc0 : IntTCC2P
    OnlyReti,           // 0xffc2 : IntTCC2T
    OnlyReti,           // 0xffc4 : IntTCC1P
    OnlyReti,           // 0xffc6 : IntTCC1T
    OnlyReti,           // 0xffc8 : IntTCA1
    OnlyReti,           // 0xffca : IntSIO1
    OnlyReti,           // 0xffcc : IntTCC0P
    OnlyReti,           // 0xffce : IntTCC0T
    OnlyReti,           // 0xffd0 : IntTXD1
    OnlyReti,           // 0xffd2 : IntRXD1
    OnlyReti,           // 0xffd4 : Int5
    OnlyReti,           // 0xffd6 : Int4
    OnlyReti,           // 0xffd8 : Int3 / IntCMP1
    OnlyReti,           // 0xffda : Int2 / IntCMP0 / IntEMG0
    OnlyReti,           // 0xffdc : Int1 / IntCMP2
    OnlyReti,           // 0xffde : Int0 / IntCMP3
    OnlyReti,           // 0xffe0 : IntSBI
    OnlyReti,           // 0xffe2 : IntTCA0
    OnlyReti,           // 0xffe4 : IntTC01
    OnlyReti,           // 0xffe6 : IntTC00
    OnlyReti,           // 0xffe8 : IntRTC
    OnlyReti,           // 0xffea : IntADC
    OnlyReti,           // 0xffec : IntLVD
    OnlyReti,           // 0xffee : IntTXD0
    OnlyReti,           // 0xfff0 : IntRXD0
    OnlyReti,           // 0xfff2 : IntSIO0
    OnlyReti,           // 0xfff4 : IntTBT
    OnlyReti,           // 0xfff6 : IntWUC
    IntWDT,             // 0xfff8 : IntWDT
    (void *)0xffff,     // 0xfffa : Reserved
    IntSWI,             // 0xfffc : IntSWI / INTUNDEF
    iap_boot            // 0xfffe : IAP UPDATE
};
#pragma section const
/*-------------------  ж ------------------------*/


















//*********************************************************************
//    : SYSTEM_INIT(void)
//  : IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨
// ע     :
//*********************************************************************
void SYSTEM_INIT(void)
{
#ifdef _DEBUG   //...  _DEBUG(ģʽ): ڷ ev board
//------------------------------------------------------------------
//  (ϵͳĬ): ʱP10趨ΪReset PinԱӰ漰¼.
    SET_P10_to_RESET_PIN;
//------------------------------------------------------------------
    FSCTRL_FSSEL = 0;                   // 0ΪĬֵбλ(bit)ڷģʽֶʼΪĬֵ 0
//------------------------------------------------------------------
#else           //...  һϵܳ(Ƿģʽ) P10(RESET) λΪһ IO 
//------------------------------------------------------------------
//-- P10趨ΪһIO ------
    SET_P10_to_IO_PIN;
//------------------------------------------------------------------
#endif



//-- ʼ IO  (λ)------
#ifdef _DEBUG   //...  _DEBUG: ڷ ev board
//------------------------------------------------------------------
//   P10/P40/P41  Debug modeڷʱ趨Ϊ룬
//  ԱӰ漰¼.
    P1DR = 0x00;
    P1CR = set8bit(11111110);           //  P10 Ϊ
    P4DR = 0x00;
    P4CR = set8bit(11111100);           //  P40/P41 Ϊ
//------------------------------------------------------------------
#else           //...  һϵܳ(Ƿģʽ)
//------------------------------------------------------------------
    P1DR = 0x00;
    P1CR = 0xff;
    P4DR = 0x00;
    P4CR = 0xff;
//------------------------------------------------------------------
#endif

//-- ʼ IO  ------
    P0DR = 0x00;
	P0CR = 0xff;
//  P1DR = 0x00;
//  P1CR = 0xff;
    P2DR = 0x00;
    P2CR = 0xff;
//  P4DR = 0x00;
//  P4CR = 0xff;
    P5DR = 0x00;
    P5CR = 0xff;
    P7DR = 0x00;
    P7CR = 0xff;
    P8DR = 0x00;
    P8CR = 0xff;
    P9DR = 0x00;
    P9CR = 0xff;

    CLR_WDT;                            // Źʱ (ι)


//--------------------------------------------------------------------------------------------------//
//  ⲿ HXTAL/LXTAL ʹͬ IO(P00/P01), ֻһ.
//.....................................................................................
//#undef    XTAL_High       // ⲿپ: #define(ʹþ) / #undef(þ) :
//#undef    XTAL_Low        // ⲿپ: #define(ʹþ) / #undef(þ) :
//          |........................................................................................
//          |---------> // ע:
//          |---------> // 1. Enable LXtal: 趨 FSCTRL.bit.b0 = 1; --> FSCTRLʹõλԪ(bit operation)
//          |---------> // 2. ⲿ¼ʱ, 乴ѡ ext low OSC:
//          |---------> //    IDE¼       : Project -> Pin Setting -> ѡ ext low OSC
//          |---------> //    Writer¼    : ѡType -> IC typeѡͬһҳҷ -> ѡ ext low OSC
//          .........................................................................................
//--------------------------------------------------------------------------------------------------//
//	кѡǷлⲿپ
//  XTAL_High_Config();

}



//*********************************************************************
//    : delay_times
//  : ʱ
// ע     : ==> t_1ms   = 0;          // ӳʱ䵥λ ms
//          : ==> t_100us = 1;          // ӳʱ䵥λ usϴ
//          : ɹ̶Ȧʱһʱ䣬ʹ÷£
//          : delay_times(t_1ms, 800);  // ӳ 800ms
//*********************************************************************
void delay_times(uchar tBase, uint x)
{
    uint  i, cgcrT;

//  uchar cgcrF[4]={ 2, 4,  8, 1 };     // پƵΪ  8MHz ʱʹô
    uchar cgcrF[4]={ 4, 8, 16, 2 };     // پƵΪ 16MHz ʱʹô

//  ϵͳڸʱ(ͨ1ͨ2ģʽ) ʱ
    if( SYSCR2_SYSCK == 0 )
    {
        cgcrT = cgcrF[CGCR_FCGCKSEL];   // 0:fc/4, 1:fc/2, 2:fc/1, 3:fc/8
        switch(tBase)
        {
            case 0:                     // t_1ms
                cgcrT *= 110;
                for(; x>0; x--)
                    for(i=0; i<cgcrT; i++){}
            break;
            case 1:                     // t_100us
                cgcrT *= 11;
                for(; x>0; x--)
                    for(i=0; i<cgcrT; i++){}
            break;
        }
    }
//  ϵͳڵʱ(12ģʽ) ʱϴ󣬲οʹã
    else for(; x>0; x--){}

    CLR_WDT;                            // Źʱ (ι)
}
/* ----------------------- IAP(Ҫ޸Ĵ˴ code) --------------------------- */
#pragma section code	c_value
void IAP_Init()
{
	// Memory address related
	IAP_Dev_define.norBootAddr = NORMAL_BOOT_ADDRESS;

	// BOOT PIN select
	IAP_Dev_define.ptrBootPinPU = IAP_BOOT_PIN_PU_REG;
	IAP_Dev_define.ptrBootPinPD = IAP_BOOT_PIN_PD_REG;
	IAP_Dev_define.ptrBootPinPRD = IAP_BOOT_PIN_PRD_REG;
	IAP_Dev_define.valBootPinBit = IAP_BOOT_PIN_BIT;
	IAP_Dev_define.valBootDefaultHL = IAP_BOOT_GPIO_DEFAULT_HIGH_LOW;
	IAP_Dev_define.valBootEnableHL =IAP_BOOT_GPIO_ENABLE_HIGH_LOW;
	
	// UART select
	IAP_Dev_define.ptrUartPinCR = IAP_UART_CR_ADR;
    IAP_Dev_define.ptrUartPinFC = IAP_UART_FC_ADR;
    IAP_Dev_define.valUartTxPin = IAP_UART_TX_PIN;
	IAP_Dev_define.valUartRxPin = IAP_UART_RX_PIN;
	IAP_Dev_define.valUATCNG    = IAP_UART_UATCNG_VALUE;
	IAP_Dev_define.valPOFFCR1   = IAP_UART_POFFCR1_VALUE;
	
	IAP_Dev_define.ptrUartTxRxBUF  = IAP_UART_TDRDBUF_ADR;
	IAP_Dev_define.ptrUartSR    = IAP_UART_SR_ADR;
	IAP_Dev_define.valUartDR    = BAUDRATE_DR_VALUE;
	IAP_Dev_define.valUartCR1   = UART_CR1_VALUE;
	IAP_Dev_define.valUartCR2   = UART_CR2_VALUE;
	IAP_Dev_define.valUartRTSEL = BAUDRATE_RTSEL_VALUE;
	
}
#pragma section code
/* ----------------------- IAP End --------------------------- */




















